//
//  Rational.cpp
//  Session 10
//
//  Created by Luis Angel on 6/4/15.
//  Copyright (c) 2015 Luis Angel. All rights reserved.
//

#include <iostream>

using namespace std;

class Rational
{
private:
	int num;
	int den;
	
	void simplify()
	{
		bool negative = false;
		if( num < 0 )	// Negative numerator?
		{
			num *= -1;	// Change sign.
			negative = true;
		}
			
		int minimum = min( num, den );
		
		int mcd = 1;
		if( num%minimum == 0 && den%minimum == 0 )
			mcd = minimum;
		else
		{
			for( int I = 2; I <= minimum/2; I++ )
			{
				if( num%I == 0 && den%I == 0 )	// Divisible?
					mcd = I;
			}
		}
		
		num /= mcd;
		den /= mcd;
		
		if( negative )
			num *= -1;	// Get back to negative number.
	}
	
public:
	Rational( int n, int d )
	{
		num = n;
		den = d;
		
		if( (num < 0 && den < 0) || den < 0 )	// Move negative sign to numerator.
		{
			num *= -1;
			den *= -1;
		}
		
		simplify();
	}
	
	Rational()
	{
		num = den = 1;
	}
	
	int getNum() const
	{
		return num;
	}
	
	int getDen() const
	{
		return den;
	}
	
	Rational add( const Rational& r ) const
	{
		int d = den * r.getDen();				// New denominator.
		int n1 = (d/den) * num;					// Adjusted numerator for this.
		int n2 = (d/r.getDen()) * r.getNum();	// Adjusted numerator for r.
		return Rational( n1+n2, d );
	}
	
	Rational multiply( const Rational& r ) const
	{
		int n = num * r.num;
		int d = den * r.den;
		return Rational( n, d );
	}
	
	void print() const
	{
		cout << num << "/" << den << endl;
	}
};


int main4()
{
	Rational r1( 2, -4 );
	Rational r2( -1, 3 );
	r1.add( r2 ).print();
	r2.multiply( r1 ).print();
	
	return 0;
}




